import 'package:flutter/material.dart';
import 'package:zrouter/router.dart';

import 'route_mapper_generator.route.dart';

void main() {
  RouterMapperInitializer.init();
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      // 此处设置路由
      onGenerateRoute: Router.getOnGenerateRoute(),
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: FirstScreen(),
    );
  }
}

class FirstScreen extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("First Screen"),
      ),
      body: Center(
          child: new Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: <Widget>[
          RaisedButton(
            onPressed: () {
              Navigator.of(context).pushNamed("priority/test");
            },
            child: Text('打开 zhihu2://priority/test'),
          )
        ],
      )),
    );
  }
}
