import '../route_mappers.dart';

class MatchResult {
  /// 用来匹配的 url
  final String url;

  /// 匹配出来的参数，它通常含有以下参数
  ///
  /// Router.KEY_ROUTER_RAW_URL = "key_router_raw_url";//原始 url，如果有跳转，则是跳转后的 url
  /// Router.KEY_ROUTER_REDIRECT_FROM = "key_router_redirect_from"; // 如果有跳转，它才是真正的原始 url
  final Map arguments;

  /// 感觉好像也可以直接返回一个 Widget
  final RouterWidgetBuilder builder;

  /// 匹配到的 class 属于哪个 package
  final String module;

  MatchResult(this.url, this.arguments, this.builder, this.module);
}
