class Consts {
}

/// 检查类型是否匹配
bool checkType(String value, String type) {
  if (isEmpty(type) || "string" == type) {
    // 如果是 string ，直接返回 true
    return true;
  }
  // 如果是空，就必须是 string
  if (isEmpty(value) && type != "string") {
    return false;
  }
  try {
    switch (type) {
      case "int":
        int.parse(value);
        break;
      case "double":
        double.parse(value);
        break;
      case "bool":
        String v = value.toLowerCase();
        if (v != "true" && v != "false") {
          throw FormatException("$value is not bool type");
        }
        break;
      default:
        break;
    }
  } on FormatException {
    return false;
  }
  return true;
}

// 字符串是否为空或者 Null
bool isEmpty(String str) {
  return str == null || str.isEmpty;
}

/// 字符串是否不为空
bool notEmpty(String str) {
  return str != null && str.isNotEmpty;
}

extension StringMatch on String {
  bool matches(String reg) {
    var matches = RegExp(reg).allMatches(this);
    return matches.length == 1 && matches.first.end == this.length;
  }
}

// 一个字符串与 reg 完全匹配的话，返回 Match，否则返回 null
Match allMatchResult(String str, String reg) {
  var matches = RegExp(reg).allMatches(str);
  if (matches.length == 1 && matches.first.end == str.length) {
    return matches.first;
  }
  return null;
}