import 'router.dart';
import 'package:flutter/widgets.dart' as w;

import 'resolver/models.dart';


typedef RouterWidgetBuilder = w.Widget Function(Map);

/// Mapper 类 models.dart 抽出来，避免编译出问题
class Mapper {
  final String template;
  final Route route;
  final RouterWidgetBuilder target;
  final int priority;
  final String module;

  Mapper(this.template, this.route, this.target, this.priority, this.module);

  @override
  String toString() {
    return """Mapper{
  template: $template, 
  route: $route, 
  target: $target, 
  priority: $priority, 
  module: $module
}""";
  }
}

class RouterMappers {
  static String _default_scheme = null;

  static String get DEFAULT_SCHEME {
    if (_default_scheme == null) {
      throw Exception("DEFAULT_SCHEME 不能为空");
    }
    return _default_scheme;
  }

  static set DEFAULT_SCHEME(String s) {
    if (_default_scheme == null) {
      _default_scheme = s;
    } else {
      throw Exception("DEFAULT_SCHEME 只能设置一次");
    }
  }

  static void addMapper(Mapper mapper) {
    Router.sMapperList.add(mapper);
  }
}
