library route_generator.builder;

import 'dart:io';

import 'package:build/build.dart';
import 'package:source_gen/source_gen.dart';
import 'route_reader.dart';
import 'routers_writer.dart';

// 读取注册的所有路由，但是不写入
Builder routeReader(BuilderOptions options) {
  if (Platform.isAndroid || Platform.isIOS || Platform.isFuchsia) {
    throw new UnsupportedError("Builder 只应该在编译时使用");
  }
  return LibraryBuilder(RouteReader(), generatedExtension: ".reader.dart");
}

// 将 [routeReader] 生成的所有路由输出到文件中
Builder routeWriter(BuilderOptions options) {
  if (Platform.isAndroid || Platform.isIOS || Platform.isFuchsia) {
    throw new UnsupportedError("Builder 只应该在编译时使用");
  }
  return LibraryBuilder(RouteWriter(options), generatedExtension: ".route.dart");
}
