import 'package:analyzer/dart/element/element.dart';
import 'package:build/build.dart';
import 'package:source_gen/source_gen.dart';
import 'package:zrouter/src/compiler/compiler_data.dart';
import 'package:zrouter/src/compiler/compiler_util.dart';

/// 一个注解数据单元
class RouteElement {
  static const importPrefix = "_zr_";
  final LibraryReader library;
  final ConstantReader annotation;
  final Element element;
  final BuildStep buildStep;
  String importString;
  String importShort;
  String displayName;

  RouteElement(this.library, this.annotation, this.element, this.buildStep) {
    final path = buildStep.inputId.path;
    final package = buildStep.inputId.package;
    importString = "package:$package/${path.replaceFirst('lib/', '')}";
    if (CompilerData.importPrefix.containsKey(importString)) {
      importShort = CompilerData.importPrefix[importString];
    } else {
      importShort = "$importPrefix${CompilerData.importPrefix.length}";
      CompilerData.importPrefix[importString] = importShort;
    }
    this.displayName = element.displayName;
    // TODO 这里就要决定是否使用构造函数了 ??
  }

  String getCreator(Map<String,dynamic> m){
    if(element is FunctionElement){
      FunctionElement e = element;

    }else if(element is ClassElement){
      ClassElement e = element;

    }
  }

}
