import 'dart:io';

import 'package:build/build.dart';
import 'package:source_gen/source_gen.dart';
import 'package:zrouter/src/compiler/compiler_data.dart';

import '../../annotations.dart';
import 'processor.dart';
import 'route_reader.dart';

/// 生成生成所有路由的集合类，所有路由在此集中注册，全局只允许有一个
class RouteWriter extends Generator {

  /// 表示是否已经生成了一个
  bool _hasWritten = false;

  BuilderOptions options;

  RouteWriter(this.options);

  @override
  String generate(LibraryReader library, BuildStep buildStep) {
    var m = library.annotatedWith(TypeChecker.fromRuntime(AppRoutes));
    if (m.isEmpty) {
      return null;
    }
    if (_hasWritten) {
      throw new UnsupportedError("应该有且只有一个类使用 @AppRoutes 注解");
    }
    _hasWritten = true;
    if (CompilerData.allRoutes.isEmpty) {
      return null;
    }
    return RouterProcessor().process(CompilerData.allRoutes, this.options);
  }
}
