import 'package:test/test.dart';
import 'package:zrouter/resolver/utils.dart' as u;

void main() {
  test("String.matches", () {
    expect("actual".matches("actual"), true);
    expect("actual".matches(r"\w{6}"), true);
    expect("actual".matches(r"\w+"), true);
    expect("actual".matches(r"^actual$"), true);
    expect("actual".matches(r"\w"), false);
    expect("123".matches(r"\w"), false);
    expect("123".matches(r"\d+"), true);
  });

  test("isEmpty", () {
    expect(u.isEmpty("actual"), false);
    expect(u.isEmpty(""), true);
    expect(u.isEmpty(null), true);
  });

  test("notEmpty", () {
    expect(u.notEmpty("actual"), true);
    expect(u.notEmpty(""), false);
    expect(u.notEmpty(null), false);
  });

  test("checkType", () {
    expect(u.checkType("actual", "string"), true);

    expect(u.checkType("actual", "int"), false);
    expect(u.checkType("123", "int"), true);
    expect(u.checkType("123.4", "int"), false);

    expect(u.checkType("actual", "bool"), false);
    expect(u.checkType("true", "bool"), true);
    expect(u.checkType("false", "bool"), true);

    expect(u.checkType("actual", "double"), false);
    expect(u.checkType("1", "double"), true);
    expect(u.checkType("1.2", "double"), true);

    expect(u.checkType("1.2", null), true);
    expect(u.checkType("1.2", ""), true);

    expect(u.checkType("", "string"), true);
    expect(u.checkType("", "int"), false);
    expect(u.checkType("", "double"), false);
    expect(u.checkType("", "bool"), false);
  });
}
